(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material'), require('@angular/cdk/drag-drop'), require('rxjs'), require('@angular/common'), require('@angular/forms'), require('@angular/cdk/collections')) :
    typeof define === 'function' && define.amd ? define('ngx-mat-multi-sort', ['exports', '@angular/core', '@angular/material', '@angular/cdk/drag-drop', 'rxjs', '@angular/common', '@angular/forms', '@angular/cdk/collections'], factory) :
    (global = global || self, factory(global['ngx-mat-multi-sort'] = {}, global.ng.core, global.ng.material, global.ng.cdk['drag-drop'], global.rxjs, global.ng.common, global.ng.forms, global.ng.cdk.collections));
}(this, (function (exports, core, material, dragDrop, rxjs, common, forms, collections) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mat-multi-sort.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatMultiSort = /** @class */ (function (_super) {
        __extends(MatMultiSort, _super);
        function MatMultiSort() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.start = (/** @type {?} */ ('asc'));
            _this.actives = [];
            _this.directions = [];
            return _this;
        }
        /**
         * @return {?}
         */
        MatMultiSort.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            _super.prototype.ngOnInit.call(this);
        };
        /**
         * @param {?} sortable
         * @return {?}
         */
        MatMultiSort.prototype.sort = /**
         * @param {?} sortable
         * @return {?}
         */
        function (sortable) {
            this.updateMultipleSorts(sortable);
            _super.prototype.sort.call(this, sortable);
        };
        /**
         * @param {?} sortable
         * @return {?}
         */
        MatMultiSort.prototype.updateMultipleSorts = /**
         * @param {?} sortable
         * @return {?}
         */
        function (sortable) {
            /** @type {?} */
            var i = this.actives.findIndex((/**
             * @param {?} activeId
             * @return {?}
             */
            function (activeId) { return activeId === sortable.id; }));
            if (this.isActive(sortable)) {
                if (this.activeDirection(sortable) === (sortable.start ? sortable.start : this.start)) {
                    this.directions.splice(i, 1, this.getNextSortDirection(sortable));
                }
                else {
                    this.actives.splice(i, 1);
                    this.directions.splice(i, 1);
                }
            }
            else {
                this.actives.push(sortable.id);
                this.directions.push(sortable.start ? sortable.start : this.start);
            }
        };
        /**
         * @param {?} sortable
         * @return {?}
         */
        MatMultiSort.prototype.isActive = /**
         * @param {?} sortable
         * @return {?}
         */
        function (sortable) {
            /** @type {?} */
            var i = this.actives.findIndex((/**
             * @param {?} activeId
             * @return {?}
             */
            function (activeId) { return activeId === sortable.id; }));
            return i > -1;
        };
        /**
         * @param {?} sortable
         * @return {?}
         */
        MatMultiSort.prototype.activeDirection = /**
         * @param {?} sortable
         * @return {?}
         */
        function (sortable) {
            /** @type {?} */
            var i = this.actives.findIndex((/**
             * @param {?} activeId
             * @return {?}
             */
            function (activeId) { return activeId === sortable.id; }));
            return this.directions[i] || (sortable.start ? sortable.start : this.start);
        };
        MatMultiSort.decorators = [
            { type: core.Directive, args: [{
                        selector: '[matMultiSort]',
                        exportAs: 'matMultiSort'
                    },] }
        ];
        return MatMultiSort;
    }(material.MatSort));
    if (false) {
        /** @type {?} */
        MatMultiSort.prototype.start;
        /** @type {?} */
        MatMultiSort.prototype.actives;
        /** @type {?} */
        MatMultiSort.prototype.directions;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mat-multi-sort-header/mat-multi-sort-header.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Column definition associated with a `MatSortHeader`.
     * @record
     */
    function C2MatSortHeaderColumnDef() { }
    if (false) {
        /** @type {?} */
        C2MatSortHeaderColumnDef.prototype.name;
    }
    var MatMultiSortHeaderComponent = /** @class */ (function (_super) {
        __extends(MatMultiSortHeaderComponent, _super);
        function MatMultiSortHeaderComponent(_intl, changeDetectorRef, _sort, _columnDef) {
            var _this = _super.call(this, _intl, changeDetectorRef, _sort, _columnDef) || this;
            _this._intl = _intl;
            _this._sort = _sort;
            _this._columnDef = _columnDef;
            _this.start = (/** @type {?} */ ('asc'));
            return _this;
        }
        /**
         * @param {?} visible
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype.__setIndicatorHintVisible = /**
         * @param {?} visible
         * @return {?}
         */
        function (visible) {
            _super.prototype._setIndicatorHintVisible.call(this, (/** @type {?} */ (visible)));
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype._handleClick = /**
         * @return {?}
         */
        function () {
            _super.prototype._handleClick.call(this);
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype._isSorted = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return this._sort.actives.findIndex((/**
             * @param {?} activeId
             * @return {?}
             */
            function (activeId) { return activeId === _this.id; })) > -1;
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype._sortId = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return this._sort.actives.findIndex((/**
             * @param {?} activeId
             * @return {?}
             */
            function (activeId) { return activeId === _this.id; })) + 1;
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype._updateArrowDirection = /**
         * @return {?}
         */
        function () {
            this._arrowDirection = this.getSortDirection();
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype._getAriaSortAttribute = /**
         * @return {?}
         */
        function () {
            if (!this._isSorted()) {
                return null;
            }
            return this.getSortDirection() === 'asc' ? 'ascending' : 'descending';
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype._renderArrow = /**
         * @return {?}
         */
        function () {
            return !this._isDisabled() || this._isSorted();
        };
        /**
         * @return {?}
         */
        MatMultiSortHeaderComponent.prototype.getSortDirection = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var i = this._sort.actives.findIndex((/**
             * @param {?} activeIds
             * @return {?}
             */
            function (activeIds) { return activeIds === _this.id; }));
            /** @type {?} */
            var direction = this._sort.directions[i];
            return this._isSorted() ? direction : (this.start || this._sort.start);
        };
        MatMultiSortHeaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[mat-multi-sort-header]',
                        exportAs: 'matMultiSortHeader',
                        template: "<div class=\"mat-sort-header-container\"\r\n     [class.mat-sort-header-sorted]=\"_isSorted()\"\r\n     [class.mat-sort-header-position-before]=\"arrowPosition == 'before'\">\r\n  <button class=\"mat-sort-header-button\" type=\"button\"\r\n          [attr.disabled]=\"_isDisabled() || null\"\r\n          [attr.aria-label]=\"_intl.sortButtonLabel(id)\"\r\n          (focus)=\"_setIndicatorHintVisible(true)\"\r\n          (blur)=\"_setIndicatorHintVisible(false)\">\r\n    <ng-content></ng-content>\r\n  </button>\r\n\r\n  <!-- Disable animations while a current animation is running -->\r\n  <div class=\"mat-sort-header-arrow\"\r\n       *ngIf=\"_renderArrow()\"\r\n       [@arrowOpacity]=\"_getArrowViewState()\"\r\n       [@arrowPosition]=\"_getArrowViewState()\"\r\n       [@allowChildren]=\"_getArrowDirectionState()\"\r\n       (@arrowPosition.start)=\"_disableViewStateAnimation = true\"\r\n       (@arrowPosition.done)=\"_disableViewStateAnimation = false\">\r\n    <div class=\"mat-sort-header-stem\"></div>\r\n    <div class=\"mat-sort-header-indicator\" [@indicator]=\"_getArrowDirectionState()\">\r\n      <div class=\"mat-sort-header-pointer-left\" [@leftPointer]=\"_getArrowDirectionState()\"></div>\r\n      <div class=\"mat-sort-header-pointer-right\" [@rightPointer]=\"_getArrowDirectionState()\"></div>\r\n      <div class=\"mat-sort-header-pointer-middle\"></div>\r\n    </div>\r\n  </div>\r\n  <div *ngIf=\"_isSorted()\">{{_sortId()}}</div>\r\n</div>\r\n",
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        animations: [
                            material.matSortAnimations.indicator,
                            material.matSortAnimations.leftPointer,
                            material.matSortAnimations.rightPointer,
                            material.matSortAnimations.arrowOpacity,
                            material.matSortAnimations.arrowPosition,
                            material.matSortAnimations.allowChildren
                        ],
                        styles: [".mat-sort-header-container{display:-webkit-box;display:flex;cursor:pointer;-webkit-box-align:center;align-items:center}.mat-sort-header-disabled .mat-sort-header-container{cursor:default}.mat-sort-header-position-before{-webkit-box-orient:horizontal;-webkit-box-direction:reverse;flex-direction:row-reverse}.mat-sort-header-button{border:none;background:0 0;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center;padding:0;cursor:inherit;outline:0;font:inherit;color:currentColor}.mat-sort-header-button::-moz-focus-inner{border:0}.mat-sort-header-arrow{height:12px;width:12px;min-width:12px;position:relative;display:-webkit-box;display:flex;opacity:0}.mat-sort-header-arrow,[dir=rtl] .mat-sort-header-position-before .mat-sort-header-arrow{margin:0 0 0 6px}.mat-sort-header-position-before .mat-sort-header-arrow,[dir=rtl] .mat-sort-header-arrow{margin:0 6px 0 0}.mat-sort-header-stem{background:currentColor;height:10px;width:2px;margin:auto;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center}.mat-sort-header-indicator{width:100%;height:2px;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center;position:absolute;top:0;left:0}.mat-sort-header-pointer-middle{margin:auto;height:2px;width:2px;background:currentColor;-webkit-transform:rotate(45deg);transform:rotate(45deg)}.mat-sort-header-pointer-left,.mat-sort-header-pointer-right{background:currentColor;width:6px;height:2px;position:absolute;top:0}.mat-sort-header-pointer-left{-webkit-transform-origin:right;transform-origin:right;left:0}.mat-sort-header-pointer-right{-webkit-transform-origin:left;transform-origin:left;right:0}"]
                    }] }
        ];
        /** @nocollapse */
        MatMultiSortHeaderComponent.ctorParameters = function () { return [
            { type: material.MatSortHeaderIntl },
            { type: core.ChangeDetectorRef },
            { type: MatMultiSort, decorators: [{ type: core.Optional }] },
            { type: undefined, decorators: [{ type: core.Inject, args: ['C2_SORT_HEADER_COLUMN_DEF',] }, { type: core.Optional }] }
        ]; };
        MatMultiSortHeaderComponent.propDecorators = {
            id: [{ type: core.Input, args: ['mat-multi-sort-header',] }],
            __setIndicatorHintVisible: [{ type: core.HostListener, args: ['mouseenter', ['true'],] }, { type: core.HostListener, args: ['longpress', ['true'],] }, { type: core.HostListener, args: ['mouseleave', ['false'],] }],
            _handleClick: [{ type: core.HostListener, args: ['click',] }],
            _getAriaSortAttribute: [{ type: core.HostBinding, args: ['attr.aria-sort',] }]
        };
        return MatMultiSortHeaderComponent;
    }(material.MatSortHeader));
    if (false) {
        /** @type {?} */
        MatMultiSortHeaderComponent.prototype.start;
        /** @type {?} */
        MatMultiSortHeaderComponent.prototype.id;
        /** @type {?} */
        MatMultiSortHeaderComponent.prototype._intl;
        /** @type {?} */
        MatMultiSortHeaderComponent.prototype._sort;
        /** @type {?} */
        MatMultiSortHeaderComponent.prototype._columnDef;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/table-data.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    TableData = /** @class */ (function () {
        // TODO refactor
        function TableData(columns, options) {
            var _this = this;
            this._nextObservable = new rxjs.Subject();
            this._previousObservable = new rxjs.Subject();
            this._sizeObservable = new rxjs.Subject();
            this._sortObservable = new rxjs.Subject();
            this._columns = new rxjs.BehaviorSubject(columns.map((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { if (c.isActive === undefined) {
                c.isActive = true;
            } return c; })));
            this._displayedColumns = this._columns.value.map((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return c.id; }));
            if (options) {
                if (options.pageSizeOptions && options.pageSizeOptions.length > 1) {
                    throw Error('Array of pageSizeOptions must contain at least one entry');
                }
                options.defaultSortParams.map((/**
                 * @param {?} s
                 * @return {?}
                 */
                function (s) {
                    if (!_this._displayedColumns.includes(s)) {
                        throw Error("Provided sort paramerter \"" + s + "\" is not a column.");
                    }
                }));
                this._sortParams = options.defaultSortParams || [];
                this._sortDirs = options.defaultSortDirs || [];
                if (this._sortParams.length !== this._sortDirs.length) {
                    this._sortDirs = this._sortParams.map((/**
                     * @return {?}
                     */
                    function () { return 'asc'; }));
                }
                this._totalElements = options.totalElements || 0;
                this._pageSizeOptions = options.pageSizeOptions || [10, 20, 50, 100];
            }
            else {
                this._pageSizeOptions = [10, 20, 50, 100];
            }
            this.pageSize = this._pageSizeOptions[0];
        }
        /**
         * @private
         * @return {?}
         */
        TableData.prototype._clientSideSort = /**
         * @private
         * @return {?}
         */
        function () {
            this._dataSource.orderData();
        };
        /**
         * @return {?}
         */
        TableData.prototype.onSortEvent = /**
         * @return {?}
         */
        function () {
            this._sortParams = this._dataSource.sort['actives'];
            this._sortDirs = this._dataSource.sort['directions'];
            this._clientSideSort();
            this._sortObservable.next();
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TableData.prototype.onPagnationEvent = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var tmpPageSize = this.pageSize;
            this.pageSize = $event.pageSize;
            this.pageIndex = $event.pageIndex;
            if (tmpPageSize !== this.pageSize) {
                this._sizeObservable.next();
            }
            else if ($event.previousPageIndex < $event.pageIndex) {
                this._nextObservable.next();
            }
            else if ($event.previousPageIndex > $event.pageIndex) {
                this._previousObservable.next();
            }
        };
        Object.defineProperty(TableData.prototype, "totalElements", {
            get: /**
             * @return {?}
             */
            function () {
                return this._totalElements;
            },
            set: /**
             * @param {?} totalElements
             * @return {?}
             */
            function (totalElements) {
                this._totalElements = totalElements;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "displayedColumns", {
            get: /**
             * @return {?}
             */
            function () {
                return this._displayedColumns;
            },
            set: /**
             * @param {?} displayedColumns
             * @return {?}
             */
            function (displayedColumns) {
                this._displayedColumns = displayedColumns;
                // this.updateSortheaders();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "dataSource", {
            get: /**
             * @return {?}
             */
            function () {
                return this._dataSource;
            },
            set: /**
             * @param {?} dataSource
             * @return {?}
             */
            function (dataSource) {
                this._dataSource = dataSource;
                if (this._sortParams.length > 0) {
                    this._dataSource.sort.actives = this._sortParams;
                    this._dataSource.sort.directions = this._sortDirs.map((/**
                     * @param {?} v
                     * @return {?}
                     */
                    function (v) { return (/** @type {?} */ (v)); }));
                    this.updateSortheaders();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TableData.prototype.updateSortheaders = /**
         * @return {?}
         */
        function () {
            var _this = this;
            // Dirty hack to display default sort column(s)
            /** @type {?} */
            var temp = Object.assign([], this._displayedColumns);
            this._displayedColumns = []; // temp_revers.reverse();
            setTimeout((/**
             * @return {?}
             */
            function () { return _this._displayedColumns = temp; }), 0);
            this._clientSideSort();
            this._sortObservable.next();
        };
        Object.defineProperty(TableData.prototype, "data", {
            set: /**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                this._dataSource.data = data;
                this._clientSideSort();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "columns", {
            get: /**
             * @return {?}
             */
            function () {
                return this._columns.value;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._columns.next(v.map((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) { if (c.isActive === undefined) {
                    c.isActive = true;
                } return c; })));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TableData.prototype.onColumnsChange = /**
         * @return {?}
         */
        function () {
            return this._columns;
        };
        /**
         * @param {?} v
         * @return {?}
         */
        TableData.prototype.updateColumNames = /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            /** @type {?} */
            var dict = new Object();
            v.forEach((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return dict[c.id] = c.name; }));
            this._columns.next(this._columns.value.map((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { c.name = dict[c.id] || c.name; return c; })));
        };
        Object.defineProperty(TableData.prototype, "nextObservable", {
            get: /**
             * @return {?}
             */
            function () {
                return this._nextObservable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "previousObservable", {
            get: /**
             * @return {?}
             */
            function () {
                return this._previousObservable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "sizeObservable", {
            get: /**
             * @return {?}
             */
            function () {
                return this._sizeObservable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "sortObservable", {
            get: /**
             * @return {?}
             */
            function () {
                return this._sortObservable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "sortParams", {
            get: /**
             * @return {?}
             */
            function () {
                return this._sortParams;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._sortParams = v;
                this._dataSource.sort.actives = this._sortParams;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "sortDirs", {
            get: /**
             * @return {?}
             */
            function () {
                return this._sortDirs;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._sortDirs = v;
                this._dataSource.sort.directions = this._sortDirs.map((/**
                 * @param {?} v
                 * @return {?}
                 */
                function (v) { return (/** @type {?} */ (v)); }));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableData.prototype, "pageSizeOptions", {
            get: /**
             * @return {?}
             */
            function () {
                return this._pageSizeOptions;
            },
            enumerable: true,
            configurable: true
        });
        return TableData;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._dataSource;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._columns;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._displayedColumns;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._clientSideSorting;
        /** @type {?} */
        TableData.prototype.pageSize;
        /** @type {?} */
        TableData.prototype.pageIndex;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._pageSizeOptions;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._totalElements;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._sortParams;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._sortDirs;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._nextObservable;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._previousObservable;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._sizeObservable;
        /**
         * @type {?}
         * @private
         */
        TableData.prototype._sortObservable;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mat-multi-sort-table-settings/mat-multi-sort-table-settings.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatMultiSortTableSettingsComponent = /** @class */ (function () {
        function MatMultiSortTableSettingsComponent() {
            this.sort = [];
        }
        Object.defineProperty(MatMultiSortTableSettingsComponent.prototype, "tableData", {
            set: /**
             * @param {?} tableData
             * @return {?}
             */
            function (tableData) {
                this._tableData = tableData;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.sort = this.getSort();
            this._tableData.sortObservable.subscribe((/**
             * @return {?}
             */
            function () { return _this.sort = _this.getSort(); }));
            this._tableData.onColumnsChange().subscribe((/**
             * @return {?}
             */
            function () { return _this.sort = _this.getSort(); }));
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.drop = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            dragDrop.moveItemInArray(this._tableData.columns, event.previousIndex, event.currentIndex);
            this._tableData.displayedColumns = this._tableData.columns.filter((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return c.isActive; })).map((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return c.id; }));
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.dropSort = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            dragDrop.moveItemInArray(this.sort, event.previousIndex, event.currentIndex);
            this.updateSort();
        };
        /**
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.toggle = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._tableData.displayedColumns = this._tableData.columns.filter((/**
             * @param {?} c
             * @return {?}
             */
            function (c) {
                if (!c.isActive) {
                    _this.sort = _this.sort.filter((/**
                     * @param {?} s
                     * @return {?}
                     */
                    function (s) { return s.id !== c.id; }));
                    console.log(_this.sort, c.id);
                }
                return c.isActive;
            })).map((/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return c.id; }));
            this.updateSort();
        };
        /**
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.getSort = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var sorting = [];
            var _loop_1 = function (i) {
                sorting.push({
                    id: this_1._tableData.sortParams[i],
                    name: this_1._tableData.columns.find((/**
                     * @param {?} c
                     * @return {?}
                     */
                    function (c) { return c.id === _this._tableData.sortParams[i]; })).name,
                    direction: this_1._tableData.sortDirs[i]
                });
            };
            var this_1 = this;
            for (var i = 0; i < this._tableData.sortParams.length; i++) {
                _loop_1(i);
            }
            return sorting;
        };
        /**
         * @param {?} id
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.remove = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            this.sort = this.sort.filter((/**
             * @param {?} v
             * @return {?}
             */
            function (v) { return v.id !== id; }));
            this.updateSort();
        };
        /**
         * @param {?} id
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.updateDirection = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            /** @type {?} */
            var i = this.sort.findIndex((/**
             * @param {?} v
             * @return {?}
             */
            function (v) { return v.id === id; }));
            if (this.sort[i].direction === 'asc') {
                this.sort[i].direction = 'desc';
            }
            else {
                this.sort[i].direction = 'asc';
            }
            this.updateSort();
        };
        /**
         * @private
         * @return {?}
         */
        MatMultiSortTableSettingsComponent.prototype.updateSort = /**
         * @private
         * @return {?}
         */
        function () {
            this._tableData.sortParams = this.sort.map((/**
             * @param {?} v
             * @return {?}
             */
            function (v) { return v.id; }));
            this._tableData.sortDirs = this.sort.map((/**
             * @param {?} v
             * @return {?}
             */
            function (v) { return v.direction; }));
            this._tableData.updateSortheaders();
        };
        MatMultiSortTableSettingsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mat-multi-sort-table-settings',
                        template: "<div class=\"table-settings\">\r\n    <div class=\"table-settings-sort\">\r\n        <mat-chip-list class=\"drag-chip-list\" cdkDropList cdkDropListOrientation='horizontal'\r\n            (cdkDropListDropped)=\"dropSort($event)\">\r\n            <mat-chip class=\"drag-chip\" *ngFor=\"let item of sort\" cdkDrag (removed)=\"remove(item.id)\"\r\n                (click)=\"updateDirection(item.id)\">\r\n                {{item.name}}:\r\n                <div class=\"sorting\" [matTooltip]=\"sortToolTip\">\r\n                    {{item.direction}}\r\n                </div>\r\n                <mat-icon matChipRemove>cancel</mat-icon>\r\n            </mat-chip>\r\n        </mat-chip-list>\r\n    </div>\r\n    <div style=\"flex: 1 1 auto;\"></div>\r\n    <div [matMenuTriggerFor]=\"menu\" class=\"table-settings-menu\">\r\n        <ng-content #menuRef></ng-content>\r\n        <!-- <button *ngIf=\"menuRef.nativeElement.childNodes.length == 0\">\r\n            Edit Columns\r\n            <mat-icon>menu</mat-icon>\r\n        </button> -->\r\n    </div>\r\n    <mat-menu #menu=\"matMenu\">\r\n        <div cdkDropList class=\"example-list\" (cdkDropListDropped)=\"drop($event)\">\r\n            <div class=\"example-box\" *ngFor=\"let column of _tableData.columns\" cdkDrag>\r\n                <mat-icon>drag_indicator</mat-icon>\r\n                <mat-checkbox [(ngModel)]=\"column.isActive\" (change)=\"toggle()\">{{column.name}}</mat-checkbox>\r\n            </div>\r\n        </div>\r\n    </mat-menu>\r\n</div>",
                        styles: [".table-settings{display:-webkit-box;display:flex}.table-settings .table-settings-menu{margin:8px 16px}.table-settings-sort{margin:auto 0}.sorting{display:inline-block;margin:0 6px;color:#757575}.sorting:hover{cursor:pointer}.example-box{height:48px;display:-webkit-box;display:flex;-webkit-box-pack:start;justify-content:flex-start;-webkit-box-align:center;align-items:center;margin:1px;padding:0 16px 0 8px}.example-box mat-icon{margin-right:16px}.example-box mat-checkbox{line-height:48px;color:rgba(0,0,0,.87);font-size:14px;font-weight:400}.example-box:hover{cursor:move;border-top:1px solid rgba(0,0,0,.12);border-bottom:1px solid rgba(0,0,0,.12)}.my-menu:hover{cursor:move}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{-webkit-transition:-webkit-transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.example-box:last-child{border:none}.example-list.cdk-drop-list-dragging .example-box:not(.cdk-drag-placeholder){-webkit-transition:-webkit-transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.drag-chip{border:1px solid rgba(0,0,0,.12);background-color:#fff}.drag-chip:hover{cursor:move;background-color:#fff}.drag-chip:focus::after,.drag-chip:hover::after{opacity:0}.drag-chip-list.cdk-drop-list-dragging .drag-chip:not(.cdk-drag-placeholder){-webkit-transition:-webkit-transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}"]
                    }] }
        ];
        /** @nocollapse */
        MatMultiSortTableSettingsComponent.ctorParameters = function () { return []; };
        MatMultiSortTableSettingsComponent.propDecorators = {
            sortToolTip: [{ type: core.Input }],
            tableData: [{ type: core.Input }]
        };
        return MatMultiSortTableSettingsComponent;
    }());
    if (false) {
        /** @type {?} */
        MatMultiSortTableSettingsComponent.prototype._tableData;
        /** @type {?} */
        MatMultiSortTableSettingsComponent.prototype.sort;
        /** @type {?} */
        MatMultiSortTableSettingsComponent.prototype.sortToolTip;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mat-multi-sort.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatMultiSortModule = /** @class */ (function () {
        function MatMultiSortModule() {
        }
        MatMultiSortModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MatMultiSortHeaderComponent, MatMultiSort, MatMultiSortTableSettingsComponent],
                        exports: [MatMultiSortHeaderComponent, MatMultiSort, MatMultiSortTableSettingsComponent],
                        imports: [
                            common.CommonModule,
                            material.MatCommonModule,
                            material.MatDividerModule,
                            dragDrop.DragDropModule,
                            material.MatIconModule,
                            material.MatCheckboxModule,
                            material.MatMenuModule,
                            material.MatButtonModule,
                            forms.FormsModule,
                            material.MatChipsModule,
                            material.MatTooltipModule
                        ]
                    },] }
        ];
        return MatMultiSortModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mat-multi-sort-data-source.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    MatMultiSortTableDataSource = /** @class */ (function (_super) {
        __extends(MatMultiSortTableDataSource, _super);
        function MatMultiSortTableDataSource(sort, clientSideSorting) {
            if (clientSideSorting === void 0) { clientSideSorting = false; }
            var _this = _super.call(this) || this;
            _this._data = new rxjs.BehaviorSubject([]);
            _this.sort = sort;
            _this.clientSideSorting = clientSideSorting;
            return _this;
        }
        Object.defineProperty(MatMultiSortTableDataSource.prototype, "data", {
            get: /**
             * @return {?}
             */
            function () {
                return this._data.value;
            },
            set: /**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                this._data.next(data);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatMultiSortTableDataSource.prototype.connect = /**
         * @return {?}
         */
        function () {
            return this._data;
        };
        /**
         * @return {?}
         */
        MatMultiSortTableDataSource.prototype.disconnect = /**
         * @return {?}
         */
        function () {
            this._data.complete();
        };
        /**
         * @return {?}
         */
        MatMultiSortTableDataSource.prototype.orderData = /**
         * @return {?}
         */
        function () {
            this._data.next(this.sortData(this._data.value, this.sort.actives, this.sort.directions));
        };
        /**
         * @param {?} data
         * @param {?} actives
         * @param {?} directions
         * @return {?}
         */
        MatMultiSortTableDataSource.prototype.sortData = /**
         * @param {?} data
         * @param {?} actives
         * @param {?} directions
         * @return {?}
         */
        function (data, actives, directions) {
            var _this = this;
            /** @type {?} */
            var _data = Object.assign(new Array(), data);
            if (this.clientSideSorting) {
                return _data.sort((/**
                 * @param {?} i1
                 * @param {?} i2
                 * @return {?}
                 */
                function (i1, i2) {
                    return _this._sortData(i1, i2, actives, directions);
                }));
            }
            return _data;
        };
        /**
         * @param {?} d1
         * @param {?} d2
         * @param {?} params
         * @param {?} dirs
         * @return {?}
         */
        MatMultiSortTableDataSource.prototype._sortData = /**
         * @param {?} d1
         * @param {?} d2
         * @param {?} params
         * @param {?} dirs
         * @return {?}
         */
        function (d1, d2, params, dirs) {
            if (d1[params[0]] > d2[params[0]]) {
                return dirs[0] === 'asc' ? 1 : -1;
            }
            else if (d1[params[0]] < d2[params[0]]) {
                return dirs[0] === 'asc' ? -1 : 1;
            }
            else {
                if (params.length > 1) {
                    params = params.slice(1, params.length);
                    dirs = dirs.slice(1, dirs.length);
                    return this._sortData(d1, d2, params, dirs);
                }
                else {
                    return 0;
                }
            }
        };
        return MatMultiSortTableDataSource;
    }(collections.DataSource));
    if (false) {
        /**
         * @type {?}
         * @private
         */
        MatMultiSortTableDataSource.prototype._data;
        /**
         * @type {?}
         * @private
         */
        MatMultiSortTableDataSource.prototype.clientSideSorting;
        /** @type {?} */
        MatMultiSortTableDataSource.prototype.sort;
    }

    exports.MatMultiSort = MatMultiSort;
    exports.MatMultiSortHeaderComponent = MatMultiSortHeaderComponent;
    exports.MatMultiSortModule = MatMultiSortModule;
    exports.MatMultiSortTableDataSource = MatMultiSortTableDataSource;
    exports.MatMultiSortTableSettingsComponent = MatMultiSortTableSettingsComponent;
    exports.TableData = TableData;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-mat-multi-sort.umd.js.map
