import { ChangeDetectorRef } from '@angular/core';
import { MatSortHeader, MatSortHeaderIntl } from '@angular/material';
import { MatMultiSort } from '../mat-multi-sort.directive';
/** Column definition associated with a `MatSortHeader`. */
interface C2MatSortHeaderColumnDef {
    name: string;
}
export declare class MatMultiSortHeaderComponent extends MatSortHeader {
    _intl: MatSortHeaderIntl;
    _sort: MatMultiSort;
    _columnDef: C2MatSortHeaderColumnDef;
    start: "desc" | "asc";
    id: string;
    constructor(_intl: MatSortHeaderIntl, changeDetectorRef: ChangeDetectorRef, _sort: MatMultiSort, _columnDef: C2MatSortHeaderColumnDef);
    __setIndicatorHintVisible(visible: string | boolean): void;
    _handleClick(): void;
    _isSorted(): boolean;
    _sortId(): number;
    _updateArrowDirection(): void;
    _getAriaSortAttribute(): "ascending" | "descending";
    _renderArrow(): boolean;
    getSortDirection(): 'asc' | 'desc' | '';
}
export {};
